diff --git a/libavformat/movenc.c b/libavformat/movenc.c
index ff234d9..85f978a 100644
--- a/libavformat/movenc.c
+++ b/libavformat/movenc.c
@@ -2411,7 +2411,9 @@ static int mov_preroll_write_stbl_atoms(AVIOContext *pb, MOVTrack *track)
     if (!sgpd_entries)
         return AVERROR(ENOMEM);
 
-    av_assert0(track->par->codec_id == AV_CODEC_ID_OPUS || track->par->codec_id == AV_CODEC_ID_AAC || track->par->codec_id == AV_CODEC_ID_MPEGH_3D_AUDIO);
+    av_assert0(track->par->codec_id == AV_CODEC_ID_OPUS ||
+               track->par->codec_id == AV_CODEC_ID_AAC ||
+               track->par->codec_id == AV_CODEC_ID_MPEGH_3D_AUDIO);
 
     if (track->par->codec_id == AV_CODEC_ID_OPUS) {
         for (i = 0; i < track->entry; i++) {
@@ -2513,7 +2515,9 @@ static int mov_write_stbl_tag(AVFormatContext *s, AVIOContext *pb, MOVMuxContext
     if (track->cenc.aes_ctr) {
         ff_mov_cenc_write_stbl_atoms(&track->cenc, pb);
     }
-    if (track->par->codec_id == AV_CODEC_ID_OPUS || track->par->codec_id == AV_CODEC_ID_AAC || track->par->codec_id == AV_CODEC_ID_MPEGH_3D_AUDIO) {
+    if (track->par->codec_id == AV_CODEC_ID_OPUS ||
+        track->par->codec_id == AV_CODEC_ID_AAC ||
+        track->par->codec_id == AV_CODEC_ID_MPEGH_3D_AUDIO) {
         mov_preroll_write_stbl_atoms(pb, track);
     }
     return update_size(pb, pos);
@@ -6847,39 +6851,39 @@ static const AVCodecTag codec_3gp_tags[] = {
 };
 
 const AVCodecTag codec_mp4_tags[] = {
-    { AV_CODEC_ID_MPEG4       , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_H264        , MKTAG('a', 'v', 'c', '1') },
-    { AV_CODEC_ID_H264        , MKTAG('a', 'v', 'c', '3') },
-    { AV_CODEC_ID_HEVC        , MKTAG('h', 'e', 'v', '1') },
-    { AV_CODEC_ID_HEVC        , MKTAG('h', 'v', 'c', '1') },
-    { AV_CODEC_ID_MPEG2VIDEO  , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_MPEG1VIDEO  , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_MJPEG       , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_PNG         , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_JPEG2000    , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_VC1         , MKTAG('v', 'c', '-', '1') },
-    { AV_CODEC_ID_DIRAC       , MKTAG('d', 'r', 'a', 'c') },
-    { AV_CODEC_ID_TSCC2       , MKTAG('m', 'p', '4', 'v') },
-    { AV_CODEC_ID_VP9         , MKTAG('v', 'p', '0', '9') },
-    { AV_CODEC_ID_AV1         , MKTAG('a', 'v', '0', '1') },
-    { AV_CODEC_ID_AAC         , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_MP4ALS      , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_MP3         , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_MP2         , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_AC3         , MKTAG('a', 'c', '-', '3') },
-    { AV_CODEC_ID_EAC3        , MKTAG('e', 'c', '-', '3') },
-    { AV_CODEC_ID_DTS         , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_TRUEHD      , MKTAG('m', 'l', 'p', 'a') },
-    { AV_CODEC_ID_FLAC        , MKTAG('f', 'L', 'a', 'C') },
-    { AV_CODEC_ID_OPUS        , MKTAG('O', 'p', 'u', 's') },
-    { AV_CODEC_ID_VORBIS      , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_QCELP       , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_EVRC        , MKTAG('m', 'p', '4', 'a') },
-    { AV_CODEC_ID_DVD_SUBTITLE, MKTAG('m', 'p', '4', 's') },
-    { AV_CODEC_ID_MOV_TEXT    , MKTAG('t', 'x', '3', 'g') },
-    { AV_CODEC_ID_BIN_DATA    , MKTAG('g', 'p', 'm', 'd') },
+    { AV_CODEC_ID_MPEG4         , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_H264          , MKTAG('a', 'v', 'c', '1') },
+    { AV_CODEC_ID_H264          , MKTAG('a', 'v', 'c', '3') },
+    { AV_CODEC_ID_HEVC          , MKTAG('h', 'e', 'v', '1') },
+    { AV_CODEC_ID_HEVC          , MKTAG('h', 'v', 'c', '1') },
+    { AV_CODEC_ID_MPEG2VIDEO    , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_MPEG1VIDEO    , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_MJPEG         , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_PNG           , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_JPEG2000      , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_VC1           , MKTAG('v', 'c', '-', '1') },
+    { AV_CODEC_ID_DIRAC         , MKTAG('d', 'r', 'a', 'c') },
+    { AV_CODEC_ID_TSCC2         , MKTAG('m', 'p', '4', 'v') },
+    { AV_CODEC_ID_VP9           , MKTAG('v', 'p', '0', '9') },
+    { AV_CODEC_ID_AV1           , MKTAG('a', 'v', '0', '1') },
+    { AV_CODEC_ID_AAC           , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_MP4ALS        , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_MP3           , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_MP2           , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_AC3           , MKTAG('a', 'c', '-', '3') },
+    { AV_CODEC_ID_EAC3          , MKTAG('e', 'c', '-', '3') },
+    { AV_CODEC_ID_DTS           , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_TRUEHD        , MKTAG('m', 'l', 'p', 'a') },
+    { AV_CODEC_ID_FLAC          , MKTAG('f', 'L', 'a', 'C') },
+    { AV_CODEC_ID_OPUS          , MKTAG('O', 'p', 'u', 's') },
+    { AV_CODEC_ID_VORBIS        , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_QCELP         , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_EVRC          , MKTAG('m', 'p', '4', 'a') },
+    { AV_CODEC_ID_DVD_SUBTITLE  , MKTAG('m', 'p', '4', 's') },
+    { AV_CODEC_ID_MOV_TEXT      , MKTAG('t', 'x', '3', 'g') },
+    { AV_CODEC_ID_BIN_DATA      , MKTAG('g', 'p', 'm', 'd') },
     { AV_CODEC_ID_MPEGH_3D_AUDIO, MKTAG('m', 'h', 'm', '1') },
-    { AV_CODEC_ID_NONE        ,    0 },
+    { AV_CODEC_ID_NONE          ,    0 },
 };
 
 const AVCodecTag codec_ism_tags[] = {